// MyExt.cpp

#include "dbgexts.h"

HRESULT CALLBACK 
outctlpassed(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	UNREFERENCED_PARAMETER(args);

	IDebugControl* pDebugControl;
	if (SUCCEEDED(pDebugClient->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
	{
		pDebugControl->ControlledOutput(DEBUG_OUTCTL_THIS_CLIENT,       DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_THIS_CLIENT\n");
		pDebugControl->ControlledOutput(DEBUG_OUTCTL_ALL_CLIENTS,       DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_ALL_CLIENTS\n");
		pDebugControl->ControlledOutput(DEBUG_OUTCTL_ALL_OTHER_CLIENTS, DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_ALL_OTHER_CLIENTS\n");
		pDebugControl->ControlledOutput(DEBUG_OUTCTL_IGNORE,            DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_IGNORE\n");
		pDebugControl->ControlledOutput(DEBUG_OUTCTL_LOG_ONLY,          DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_LOG_ONLY\n");

		pDebugControl->Release();
	}
	return S_OK;
}

HRESULT CALLBACK 
outctlcreate(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	UNREFERENCED_PARAMETER(args);

	IDebugClient* pDebugCreated;
	if (SUCCEEDED(pDebugClient->CreateClient(&pDebugCreated)))
	{
		IDebugControl* pDebugControl;
		if (SUCCEEDED(pDebugCreated->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
		{
			pDebugControl->ControlledOutput(DEBUG_OUTCTL_THIS_CLIENT,       DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_THIS_CLIENT\n");
			pDebugControl->ControlledOutput(DEBUG_OUTCTL_ALL_CLIENTS,       DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_ALL_CLIENTS\n");
			pDebugControl->ControlledOutput(DEBUG_OUTCTL_ALL_OTHER_CLIENTS, DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_ALL_OTHER_CLIENTS\n");
			pDebugControl->ControlledOutput(DEBUG_OUTCTL_IGNORE,            DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_IGNORE\n");
			pDebugControl->ControlledOutput(DEBUG_OUTCTL_LOG_ONLY,          DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_LOG_ONLY\n");

			pDebugControl->Release();
		}
		pDebugCreated->Release();
	}
	return S_OK;
}

HRESULT CALLBACK 
outctlthis(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	UNREFERENCED_PARAMETER(args);

	IDebugClient* pDebugCreated;
	if (SUCCEEDED(pDebugClient->CreateClient(&pDebugCreated)))
	{
		IDebugControl* pDebugControl;
		if (SUCCEEDED(pDebugCreated->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
		{
			pDebugControl->ControlledOutput(DEBUG_OUTCTL_THIS_CLIENT | DEBUG_OUTCTL_NOT_LOGGED, DEBUG_OUTPUT_NORMAL, "DEBUG_OUTCTL_THIS_CLIENT | DEBUG_OUTCTL_NOT_LOGGED\n");
			pDebugControl->Release();
		}
		pDebugCreated->Release();
	}
	return S_OK;
}

HRESULT CALLBACK 
outctlexecute(PDEBUG_CLIENT pDebugClient, PCSTR args)
{
	IDebugClient* pDebugCreated;
	if (SUCCEEDED(pDebugClient->CreateClient(&pDebugCreated)))
	{
		IDebugControl* pDebugControl;
		if (SUCCEEDED(pDebugCreated->QueryInterface(__uuidof(IDebugControl), (void **)&pDebugControl)))
		{
			pDebugControl->Execute(DEBUG_OUTCTL_THIS_CLIENT | DEBUG_OUTCTL_NOT_LOGGED, args, DEBUG_EXECUTE_NOT_LOGGED | DEBUG_EXECUTE_NO_REPEAT);
			pDebugControl->Release();
		}
		pDebugCreated->Release();
	}
	return S_OK;
}
